#!/usr/bin/env node
import * as ts from 'typescript';
import {
  generateDtsBundle,
  type EntryPointConfig,
} from 'dts-bundle-generator/dist/bundle-generator';

export function dts({
  source,
  dist,
  project,
}: {
  source: string;
  dist: string;
  project: string;
}): void {
  const entry: EntryPointConfig = {
    filePath: source,
    failOnClass: false,
    libraries: {
      importedLibraries: ['eslint-define-config'],
    },
    output: {
      inlineDeclareExternals: false,
      inlineDeclareGlobals: false,
      sortNodes: false,
      noBanner: false,
      respectPreserveConstEnum: false,
      exportReferencedTypes: true,
    },
  };

  const generatedDts = generateDtsBundle([entry], {
    preferredConfigPath: project,
    followSymlinks: false,
  });

  ts.sys.writeFile(dist, generatedDts[0]);
}
